/*//////////////////////////////////////////////////////////////////////////////
Éléments JavaScript pour l'utilisation de base de Cahier de Prépa

* Les fonctions communes aux visualisations avec ou sans droit d'édition sont
disponibles dans commun.js : ajaxSend, affiche, popup, reconnect
//////////////////////////////////////////////////////////////////////////////*/

////////////////////////////////////////////////////////////////////////////
// Modification des éléments (nécessite le chargement complet de la page) //
////////////////////////////////////////////////////////////////////////////
$( function() {

  ////////////////////////////////////////
  // Transferts de documents personnels //
  ////////////////////////////////////////

  // Envoi de documents pour les élèves (Transfert de copies)
  $('.transfert button.icon-ok').on("click", function(e) {
    e.preventDefault();
    // Test de connexion
    // Si reconnect() appelée, le paramètre connexion sert à obtenir un retour
    // en état ok/nok pour affichage si nok. Si ok, on réécrit le message. 
    $.ajax({url: 'ajax.php',
            method: "post",
            data: 'verifconnexion=1',
            dataType: 'json',
            el: $(this),
            fonction: function(el) {
              el.removeClass('clignote');
              // Pour ne pas rater le chargement
              $('#log').hide();
              $('#load').html('<p class="clignote">Transfert en cours<span></span></p><img src="js/ajax-loader.gif">');
              // Envoi réel du fichier ou des données
              var form = el.parent().parent();
              var data = new FormData(form[0]);
              data.append('id',form.parent().data('id'));
              // Envoi
              $.ajax({url: 'ajax.php',
                      xhr: function () { // Évolution du transfert
                        var xhr = $.ajaxSettings.xhr();
                        if (xhr.upload)
                          xhr.upload.addEventListener('progress', function (e) {
                            if (e.lengthComputable)
                              $('#load span').html(' - ' + Math.round(e.loaded / e.total * 100) + '%');
                          }, false);
                        return xhr;
                      },
                      method: "post",
                      data: data,
                      dataType: 'json',
                      contentType:false,
                      processData:false
              });
            }
    });
  });

  // Téléchargement des documents en cliquant sur le nom
  $('.transfert a span').parent().css('cursor','pointer').on("click", function() {
    $(this).siblings('.icon-download').click();
  });

  // Bouton de téléchargement d'un document
  $('.transfert a.icon-download').on("click",function() {
    // Test de connexion : on fait le téléchargement en get, donc on doit
    // être connecté en connection non light avant
    $.ajax({url: 'ajax.php',
            method: "post",
            data: 'verifconnexion=1',
            dataType: 'json',
            el: $(this).parent(),
            fonction: function(el) {
              $('#log').hide();
              window.location.href = 'transferts.php?dl=' + el.data('id') + '&verif=' + el.data('verif');
            }
    });
  });

  // Bouton de suppression d'un document
  $('.transfert a.icon-supprime').on("click", function() {
    var ligne = $(this).parent();
    // Demande de confirmation
    popup('<h3>Demande de confirmation</h3><p>Vous allez supprimer un document que vous avez envoyé. Vos professeurs/colleurs qui pouvaient le voir ne pourront plus le récupérer après cela. Cette action n\'est pas annulable.</p><p class="confirmation"><button class="icon-ok"></button>&nbsp;&nbsp;&nbsp;<button class="icon-annule"></button></p>',true);
    $('#fenetre .icon-ok').on("click", function () {
      // Envoi
      $.ajax({url: 'ajax.php',
              method: "post",
              data: { action:'suppr-transdocs', id:ligne.data('id'), transfert: ligne.parent().data('id') },
              dataType: 'json',
              el: ligne,
              fonction: function(el) {
                el.remove();
              }
      });
      $('#fenetre,#fenetre_fond').remove();
    });
    $('#fenetre .icon-annule').on("click",function () {
      $('#fenetre,#fenetre_fond').remove();
    });
  });

});
