<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Script pour transferts.php et transferts-eleves.php
// Script lancé par transferts.php
// Contient une fonction :
//  * genere_recherche($mysqli,$autorisation,$cle) retourne la requete de
// sélection demandée par l'utilisateur avec les paramètres de la page ; elle
// affiche simultanément la topbarre de recherche, donc à positionner aux
// endroits nécessaires.
// $cle est la clé de la matière ("general" si pas de matière associée).
// Lance le téléchargement si besoin (paramètre dl ou dltransfert).

////////////////////////////////////////////////////////
// Restrictions d'affichage de la liste et début HTML //
////////////////////////////////////////////////////////
function genere_recherche($mysqli,$autorisation,$cle)  {
  // Partie commune à l'affichage prof/colleur et l'affichage élève, réalisé par transferts-eleves.php

  // Restrictions sur la sélection des transferts, venant de la barre de recherche
  $requete = '';
  $select_types = '<option value="encours">Transferts en cours</option><option value="termines">Transferts terminés</option>';
  switch ( $_REQUEST['type'] ?? '' )  {
    case 'encours':  $requete = 'AND deadline>NOW()'; $select_types = str_replace('encours"','encours" selected',$select_types);   break;
    case 'termines': $requete = 'AND deadline<NOW()'; $select_types = str_replace('termines"','termines" selected',$select_types);
  }

  // Sens : type&1 = 0 si depuis les élèves, 1 si vers les élèves
  $select_sens = '<option value="vers">envoyés vers vous</option><option value="depuis">envoyés par vous</option>';
  switch ( $_REQUEST['sens'] ?? '' )  {
    case 'vers':   $requete .= ' AND ( type & 1 ) = '.intval( $autorisation == 2 ); $select_sens = str_replace('vers"','vers" selected',$select_sens); break;
    case 'depuis': $requete .= ' AND ( type & 1 ) = '.intval( $autorisation != 2 ); $select_sens = str_replace('depuis"','depuis" selected',$select_sens);
  }

  // Recherche sur du texte
  $recherche = '';
  if ( $_REQUEST['recherche'] ?? '' )
    $requete .= ' AND ( titre LIKE "%'.$mysqli->real_escape_string($recherche = htmlspecialchars($_REQUEST['recherche'])).'%" OR indications LIKE "%'.$mysqli->real_escape_string($recherche).'%" )';

  // Ordre d'affichage des transferts - CLE est à remplacer par $cle à l'affichage
  $iconesordre = <<< FIN
    <a class="icon-chronodesc" onclick="window.location='?$cle&amp;ordre=chrono-inv&amp;type='+$('#type').val()+'&amp;sens='+$('#sens').val()+'&amp;recherche='+$('.topbarre input').val();" title="Classer les transferts par ordre chronologique inversé"></a>
    <a class="icon-chronoasc" onclick="window.location='?$cle&amp;ordre=chrono&amp;type='+$('#type').val()+'&amp;sens='+$('#sens').val()+'&amp;recherche='+$('.topbarre input').val();" title="Classer les transferts par ordre chronologique"></a>
    <a class="icon-alphadesc" onclick="window.location='?$cle&amp;ordre=alpha-inv&amp;type='+$('#type').val()+'&amp;sens='+$('#sens').val()+'&amp;recherche='+$('.topbarre input').val();" title="Classer les transferts par ordre alphabétique inversé"></a>
    <a class="icon-alphaasc" onclick="window.location='?$cle&amp;ordre=alpha&amp;type='+$('#type').val()+'&amp;sens='+$('#sens').val()+'&amp;recherche='+$('.topbarre input').val();" title="Classer les transferts par ordre alphabétique"></a>
FIN;
  switch ( $_REQUEST['ordre'] ?? '' )  {
    case 'alpha':      $requete .= ' ORDER BY prefixe ASC';   $ordre = 'alphaasc'; break;
    case 'alpha-inv':  $requete .= ' ORDER BY prefixe DESC';  $ordre = 'alphadesc'; break;
    case 'chrono':     $requete .= ' ORDER BY GREATEST(deadline,dispo) ASC';  $ordre = 'chronoasc'; break;
    case 'chrono-inv': $requete .= ' ORDER BY GREATEST(deadline,dispo) DESC';  $ordre = 'chronodesc'; break;
    default:           $ordre = 'chronodesc'; // Pas de requête pour l'affichage de la page vide
  }
  $iconesordre = str_replace($ordre,"$ordre actuel",$iconesordre);

  // Barre de recherche
  echo <<< FIN

  <p id="recherchetransfert" class="topbarre">
$iconesordre
    <select id="type" onchange="$('.topbarre .actuel').click();">
      <option value="tout">Tous les transferts</option>$select_types
    </select>
    <select id="sens" onchange="$('.topbarre .actuel').click();">
      <option value="tout">dans les deux sens</option>$select_sens
    </select>
    <span class="icon-recherche" onclick="$('.topbarre .actuel').click();"></span>
    <input type="text" value="$recherche" onchange="$('.topbarre .actuel').click();" placeholder="Rechercher un mot...">
  </p>

FIN;
  return $requete;
}

////////////////////////////////
// Récupération d'un document //
////////////////////////////////
if ( isset($_REQUEST['dl']) && ctype_digit($id = $_REQUEST['dl']) && isset($_REQUEST['verif']) )  {
  
  // Pas en mode lecture
  if ( $mode_lecture )  {
    debut($mysqli,'Transferts de documents personnels','Les téléchargements ne sont pas possible en mode lecture.',$autorisation,' ',$donnees);
    echo $icones;
    fin(true);
  }
  
  // Vérification de l'identifiant du document
  $requete = ( $autorisation == 2 ) ? "eleve = ${_SESSION['id']} AND dispo < NOW()" : 'FIND_IN_SET(matiere,\''.str_replace('c','',$_SESSION['matieres']).'\')';
  $resultat = $mysqli->query("SELECT type, lien, prefixe, matiere, transfert, eleve, utilisateur, ext, numero
                              FROM transdocs LEFT JOIN transferts ON transfert = transferts.id
                              WHERE transdocs.id = $id AND $requete");
  if ( !$resultat->num_rows )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Vérification du code de téléchargement
  if ( $_REQUEST['verif'] != sha1("$id${r['lien']}$mdp") )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }

  // Vérification du droit d'accès pour les encadrants
  if ( $autorisation > 2 )  {
    $edition = acces(32-($r['type']<<1),$matiere,$titre,$actuel,$mysqli);
    // Sauf pour les profs de la matière, on ne peut voir que ses propres docs
    // si transfert vers les élèves (type&1=1)
    if ( ( $edition < 2 ) && ( $r['type'] & 1 ) && ( $r['utilisateur'] != $_SESSION['id'] ) )  {
      debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,'transferts');
      $mysqli->close();
      fin();
    }
    // Récupération du nom de l'élève
    $resultat = $mysqli->query("SELECT CONCAT(nom, ' ', prenom) AS nom FROM utilisateurs WHERE id = ${r["eleve"]}");
    $eleve = ' - '.$resultat->fetch_row()[0];
    $resultat->free();
  }
  else
    $eleve = '';

  // Récupération du nombre de documents : si un seul, pas de numérotation
  $resultat = $mysqli->query("SELECT * FROM transdocs WHERE transfert = ${r['transfert']} AND eleve = ${r['eleve']}");
  $nom = ( $resultat->num_rows > 1 ) ? "${r['prefixe']}$eleve - ${r['numero']}.${r['ext']}" : "${r['prefixe']}$eleve.${r['ext']}";
  $resultat->free();
  $mysqli->close();
  
  // Mise à disposition du fichier
  header('Content-Type: '.transforme_extension($r['ext'],1));
  header("Content-Disposition: attachment; filename=\"$nom\"");
  readfile("documents/${r['lien']}/${r['eleve']}_$id.${r['ext']}");
  exit();
}

////////////////////////////////////////////////////
// Récupération de plusieurs documents d'un coup  //
////////////////////////////////////////////////////
// Seulement pour les encadrants
if ( isset($_REQUEST['dltransfert']) && ctype_digit($id = $_REQUEST['dltransfert']) && ( $autorisation > 2 ) && isset($_REQUEST['verif']) )  {
  
  // Pas en mode lecture
  if ( $mode_lecture )  {
    debut($mysqli,'Transferts de documents personnels','Les téléchargements ne sont pas possible en mode lecture.',$autorisation,' ',$donnees);
    echo $icones;
    fin(true);
  }

  // Vérification de l'identifiant du transfert
  $resultat = $mysqli->query("SELECT lien, prefixe, matiere, type FROM transferts
                              WHERE id = $id AND FIND_IN_SET(matiere,'".str_replace('c','',$_SESSION['matieres']).'\')');
  if ( !$resultat->num_rows )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }
  $transfert = $resultat->fetch_assoc();
  $resultat->free();
  
  // Vérification du code de téléchargement
  if ( $_REQUEST['verif'] != sha1("$id${r['lien']}$mdp") )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }

  // Vérification du droit d'accès pour les encadrants
  $edition = acces(32-($r['type']<<1),$matiere,$titre,$actuel,$mysqli);
  
  // Création de l'archive
  $zip = new ZipArchive();
  $nomzip = 'archive'.sha1($transfert['prefixe']);
  if ( $zip->open( "documents/${transfert['lien']}/$nomzip.zip", ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE ) !== True )  {
    debut($mysqli,'Transfert de documents','Le fichier zip ne peut pas être créé. Vous devriez contacter l\'administrateur.',$autorisation,' ');
    $mysqli->close();
    fin();
  }
  
  // Si seulement certains documents demandés
  $requete = ( isset($_REQUEST['ids']) && count($ids = array_filter(explode(',',$_REQUEST['ids']),'ctype_digit')) ) ? 'AND FIND_IN_SET(d.id,\''.implode(',',$ids).'\')' : '';
  $requete .= ( $edition < 2 ) ? " AND utilisateur = ${_SESSION['id']}" : '';
  
  // Récupération des documents+noms d'élèves
  $resultat = $mysqli->query("SELECT d.eleve, utilisateur, numero, d.id, ext, CONCAT(nom,' ',prenom) AS nom, n
                              FROM transdocs AS d LEFT JOIN utilisateurs ON d.eleve = utilisateurs.id
                              LEFT JOIN ( SELECT COUNT(*) AS n, eleve FROM transdocs WHERE transfert = $id GROUP BY eleve ) AS ds ON d.eleve = ds.eleve 
                              WHERE transfert = $id $requete ORDER BY nom, numero");
  // Aucun document trouvé
  if ( !$resultat->num_rows )  {
    debut($mysqli,'Transfert de documents','Aucun document n\'a été trouvé.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }
  
  // Fabrication de l'archive
  while ( $r = $resultat->fetch_assoc() )  {
    $nom = ( $r['n'] > 1 ) ? "${transfert['prefixe']} - ${r['nom']} ${r['numero']}.${r['ext']}" : "${transfert['prefixe']} - ${r['nom']}.${r['ext']}";
    $zip->addFile("documents/${transfert['lien']}/${r['eleve']}_${r['id']}.${r['ext']}", $nom );
  }
  $resultat->free();
    
  // Téléchargement de l'archive
  if ( $zip->close() )  {
    header('Content-type: application/zip');
    header("Content-Disposition: attachment; filename=\"${transfert['prefixe']} - ".date('y-m-d H:i').'.zip"');
    readfile("documents/${transfert['lien']}/$nomzip.zip");
    unlink("documents/${transfert['lien']}/$nomzip.zip");
    exit();
  }
  else  {
    debut($mysqli,'Transfert de documents','Une erreur s\'est produite lors de la génération du fichier zip. Vous devriez contacter l\'administrateur.',$autorisation,'transferts');
    $mysqli->close();
    fin();
  }
}

?>
